package org.jeecg.modules.ctop.job;

import cn.com.ctop.common.module.entity.CtopOauthToken;
import cn.com.ctop.common.module.service.ICtopOauthTokenService;
import cn.com.ctop.common.module.utils.CtopAdConstant;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaishouInterfaceService;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.util.DateUtils;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Date;
import java.util.List;

/**
 * 广告计划分天报表
 *
 * @author syh
 */
@Slf4j
public class KuaishouDailyCampaignReportLoadJob implements Job {
    @Autowired
    private ICtopOauthTokenService tokenService;
    @Autowired
    private IKuaishouInterfaceService kuaishouInterfaceService;

    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        Thread thread = new Thread() {
            @Override
            public void run() {
                Date deleteDate = DateUtils.addDay(new Date(), -2);
                kuaishouInterfaceService.deleteHourlyReport(deleteDate);
                Date getDate = DateUtils.addDay(new Date(), -1);
                //1:查询当日数据
                List<CtopOauthToken> tokens = tokenService.getTokenListByType(CtopAdConstant.PLATFORM_TYPE_KUAISHOU);
                if (null == tokens || tokens.size() <= 0) {
                    log.info("定时获取头条数据异常：为获取到可用的token");
                    return;
                }

                log.info("快手物料数据同步完成");

                tokens.forEach(token -> {

                    //获取广告计划信息数据
                    kuaishouInterfaceService.getAdvertiserCampaignReportDaily(token, getDate, getDate);

                });
            }
        };
        thread.start();

    }
}
